LeetCode---twoSum

来源:互联网 发布:网络直播需要什么资质 编辑:程序博客网 时间:2024/06/11 16:13

题目:Given an array of integers, return indices of the two numbers such that they add up to a specific target.You may assume that each input would have exactly one solution, and you may not use the same element twice.

example:

Given nums = [2, 7, 11, 15], target = 9,Because nums[0] + nums[1] = 2 + 7 = 9,return [0, 1].
input:[2,3,3,4], 6
output:[1,2]
分析:暴力解法应该是O(n*n),要提高搜索效率应该用hashMap,hashMap只能通过key来找value,所以数组值为key,下标为value;但是键相同值覆盖,但是
遍历是从前往后的,覆盖也是后面覆盖前面所以无影响。
import java.util.*;class Solution {    public int[] twoSum(int[] nums, int target) {        HashMap<Integer,Integer> map = new HashMap<Integer,Integer>();        int[] res = new int[2];        for(int i=0;i<nums.length;i++) {        map.put(nums[i], i);        }        for(int i=0;i<nums.length;i++) {        if(map.containsKey(target - nums[i]) && target-nums[i] != nums[i]) {//错误,应为i!=map.get(target - nums[i])        res[0] = i;        res[1] = map.get(target - nums[i]);        break;        }        }        return res;    }}
//只需一次遍历就够了,完美解法
public int[] twoSum(int[] nums, int target) {    Map<Integer, Integer> map = new HashMap<>();    for (int i = 0; i < nums.length; i++) {        int complement = target - nums[i];        if (map.containsKey(complement)) {            return new int[] { map.get(complement), i };        }        map.put(nums[i], i);    }    throw new IllegalArgumentException("No two sum solution");}

原创粉丝点击